#! /bin/ksh
#**********************************************************************#
#       Name:      start.sh                                            #
#       Funktion:  Updateroutine                                       #
#                  (Sichern, Aktualisieren und Konvertieren)           #
#----------------------------------------------------------------------#
#Parameter $1 bis $4 werden aus dem Script instxoil uebergeben         #
#$1 = Laufzeitumgebung      (z.B. /u/xpoint/?cu)                       #
#$2 = Protokolldatei        (z.B. /u/xpoint/?cu/LISTE/UPDPRT.DRU)      #
#$3 = ran-Befehl            (z.B. /etc/ran oder /etc/ranbcu)           #
#$4 = Sicherungsverzeichnis (z.B. /u/xpoint/xpva_?cu)                  #
#**********************************************************************#
#PROTO=/u/xpoint/acu/LISTE/UPDPRT.DRU
#ACUVR=/u/xpoint/acu
OSVAR=`uname`
ACUVR=$1
export ACUVR
PROTO=$2
export PROTO
RUNCBL=$3
ACUSVR=$4
###
###--------------- Loeschen + Neuanlage xpva_[Instanz]
###
clear
echo "                                                         "
echo " * Xpoint Software GmbH, Buchenstr.6, 95339 Neuenmarkt * "
echo " ------------------------------------------------------- "
echo "    X-oil Update $updversion                             "
echo " ------------------------------------------------------- "
echo "                                                         "
echo "                                                         "
echo "    Installationsschritte:                               "
echo "                                                         "
/bin/rm -rf $4 2>> $PROTO
XX=`head -1 $ACUVR/DATEN/LSSTEUER`
KUNDE=`echo $XX`
echo " -- Beginn start.sh ------------------------------------ " > $PROTO
echo "                                                         " >> $PROTO
echo " ------------------------------------------------------- " >> $PROTO
echo "    X-oil Update $updversion                             " >> $PROTO
echo " ------------------------------------------------------- " >> $PROTO
echo "                                                         " >> $PROTO
echo "    Kundenkennung: $KUNDE                                " >> $PROTO
echo "    Instanz:       $ACUVR                                " >> $PROTO
echo "                                                         " >> $PROTO
echo "    Installationsschritte:                               " >> $PROTO
echo "                                                         " >> $PROTO
mkdir $4 2>> $PROTO
###
###--------------- sekundaere cblconfig abstellen, damit die
###--------------- alle die aufgerufenen Programme in der richtigen
###--------------- Instanz laufen!!
###
#hw#???#cp xpv/cblconfig $ACUVR
###
###--------------- Aufraeumarbeiten VOR dem Update
###
echo "    - bernahme Archivdaten            "
echo "    - bernahme ARCHIV in ZWSORT, SP098" >> $PROTO
cd $ACUVR
$RUNCBL SP098
###
###--------------- ALLE Programme nach ../xpva_[Instanz] sichern
###
echo "    - Programmstand (alt) sichern"
echo "    - Programmstand (alt) sichern" >> $PROTO
cd $ACUVR
for i in *.acu
 do
 cp $i $4 2>> $PROTO
done
###--------------- xo037D2 loeschen
cd $ACUVR
/bin/rm -f xo037D2.acu 2>> $PROTO
###
###--------------- Kopieren der Programme nach /u/xpoint/[Instanz]
###
echo "    - Programmstand (neu) installieren"
echo "    - Programmstand (neu) installieren" >> $PROTO
cd /u/xpoint/xpv
for i in *.acu
 do
 cp $i $ACUVR 2>> $PROTO
done
###
###--------------- Hilfetexte aktualisieren
###
echo "    - Hilfetexte aktualisieren"
echo "    - Hilfetexte aktualisieren" >> $PROTO
cd /u/xpoint/xpv
cp -r X/HLP/* $ACUVR/X/HLP/ 2>> $PROTO
###
###--------------- weitere Systemdateien aktualisieren
###                (Scripte, Bitmaps, etc.)
###
echo "    - Systemdateien von X-oil aktualisieren"
echo "    - Systemdateien von X-oil aktualisieren" >> $PROTO
cd /u/xpoint/xpv
cp work/XP/progfil $ACUVR/work/XP/ 2>> $PROTO
###
###
#echo "    - Kurzbefehle aktualisieren"
echo "    - Kurzbefehle aktualisieren"
echo "    - Kurzbefehle aktualisieren" >> $PROTO
cp ucb/XP/* $ACUVR/ucb/XP/ 2>> $PROTO
chmod -R 777 $ACUVR/ucb/XP/*
###
###--------------- Programmauswahl, Administration Passwoerter
###--------------- xpnachtlauf sichern
###
cp  $ACUVR/SCRIPTS/xpnachtlauf $ACUVR/SCRIPTS/xpnachtlauf.$updversion 2>> $PROTO
cp  $ACUVR/SCRIPTS/archivx2    $ACUVR/SCRIPTS/archivx2.$updversion    2>> $PROTO
cp  $ACUVR/SCRIPTS/archivxo    $ACUVR/SCRIPTS/archivxo.$updversion    2>> $PROTO
###
###--------------- neue Scripte bereit stellen
###--------------- neue Bilder fuer Buttons (z.B. Tool-Bar)
###
cd /u/xpoint/xpv
cp  -r SCRIPTS/* $ACUVR/SCRIPTS/ 2>> $PROTO
#hw###########################################################
###
###--------------- Bei Weissert muss das xpnachtlauf um einen Zusatz
###--------------- ergnzt werden!
#hw file1=$ACUVR/SCRIPTS/xpnachtlauf
#hw case $KUNDE in
#hw weissert_old) case $(head -1 ${file1} | grep "#!/bin/bash") in
#hw           "") echo "#!/bin/bash"  > /tmp/xp1_$$
#hw               cat ${file1}       >> /tmp/xp1_$$
#hw               cp /tmp/xp1_$$ ${file1}
#hw               rm /tmp/xp1_$$
#hw               ;;
#hw           esac
#hw           ;;
#hw esac
#hw###########################################################
###--------------- Administration Listenverwaltung (../X/SYS/LISTVW)
###--------------- aus csv-Datei (../word/texte/allelist.csv)
###--------------- aufbauen
echo "    - Aktualisierung Listenbezeichnungen, FF512 "
echo "    - Aktualisierung Listenbezeichnungen, FF512 " >> $PROTO
cp /u/xpoint/xpv/word/texte/allelist.csv $ACUVR/word/texte/ 2>> $PROTO
cd $ACUVR
$RUNCBL FF512
###--------------- 
###--------------- Datei TARGET nach DATEN kopieren
###--------------- 
#hw echo "    - TARGET-Datei kopieren " >> $PROTO
#hw cp /u/xpoint/xpv/DATEN/TARGET* $ACUVR/DATEN/ 2>> $PROTO
###
###--------------- Aufruf der Konvertierungsprogramme
###
#hw#echo "    - Konvertierungsprogramme starten"
#hw#echo "    - Konvertierungsprogramme" >> $PROTO
###--------------- Konvertierung Fremdsprachendatei wegen Anpassungen
###--------------- vom Druckbild der Rechnungen
#hw#echo "      Konvertierung: Fremdsprachendatei" >> $PROTO
#hw#cd $ACUVR
#hw#$RUNCBL FF5081
###--------------- Konvertierung Bankenstamm
#hw#echo "      Konvertierung: Bankenstamm" >> $PROTO
#hw#cd $ACUVR
#hw#$RUNCBL FF563
###
###--------------- Matchcodedatei neuaufbauen
###
#hw#echo "    - Neuaufbau Matchcodedatei... bitte warten!"
#hw#echo "      (Dieser Vorgang kann einige Minuten in Anspruch nehmen!)"
#hw#echo "    - Neuaufbau Matchcodedatei, SP021                       " >> $PROTO
#hw#cd $ACUVR
#hw#$RUNCBL SP021
###--------------- Sepa-Vorlage
#hw#cd /u/xpoint/xpv/
#hw#cp word/texte/sepa $ACUVR/word/texte/sepa 2>> $PROTO
#hw#echo "    - SEPA-Vorlage eintragen"
#hw#cd $ACUVR
#hw#$RUNCBL FF570
#hw#rm -f $ACUVR/word/texte/sepa
###--------------- Menuedatei, Eintraege ergaenzen
#hw
cd /u/xpoint/xpv/
cp word/texte/meninput.csv $ACUVR/meninput.csv 2>> $PROTO
echo "    - Mendatei aktualisieren"
echo "    - Mendatei aktualisieren" >> $PROTO
cd $ACUVR
$RUNCBL xomened 2>> $PROTO
rm -f $ACUVR/meninput.csv
#hw# -------------------------------------------------------------
#hw# --- nur fr Update 12.2013 !!!
#hw# -------------------------------------------------------------
###
###--------------- Rechnungsarchive bereinigen
###
echo "    - Rechnungsarchive bereinigen"
echo "    - Rechnungsarchive bereinigen" >> $PROTO
rm -f $ACUVR/gzip
rm -f $ACUVR/gunzip
cd $ACUVR
./SCRIPTS/archivkorr $ACUVR >> $PROTO 2>&1
#hw# -------------------------------------------------------------
###
###--------------- eventuell vorhandenen Bugfix-Ordner einspielen
###
cd /u/xpoint
[ -d $bugfix ] && echo "    - Bugfixes einspielen"
[ -d $bugfix ] && cp -R $bugfix/* $ACUVR 2>> $PROTO
[ -d $bugfix ] && echo "    - Bugfixes eingespielt" 2>> $PROTO
###
###--------------- Rechte auf die wichtigsten Verzeichnisse setzen
###
echo "    - Rechte setzen... bitte warten!"
echo "      (Dieser Vorgang kann einige Minuten in Anspruch nehmen!)"
echo "    - Rechte setzen"   >> $PROTO
chmod 777 $ACUVR/DATEN/*   2>> $PROTO
chmod 777 $ACUVR/work/xo/* 2>> $PROTO
chmod 777 $ACUVR/LISTE/*   2>> $PROTO
chmod 777 $ACUVR/X/SYS/*   2>> $PROTO
chmod 777 $ACUVR/X/XO1/*   2>> $PROTO
chmod 777 $ACUVR/X/XO2/*   2>> $PROTO
chmod 777 $ACUVR/DATXP/*   2>> $PROTO
chmod 777 $ACUVR/SCRIPTS/* 2>> $PROTO
$ACUVR/SCRIPTS/modus 2> /dev/null >> /dev/null
###
###--------------- Version fixieren
###
cd $ACUVR
echo "    - Version $updversion fixieren"
echo "    - Version $updversion fixieren" >> $PROTO
cat $ACUVR/acuversion >> acuversion.alt 2>> $PROTO
echo "Xenergy Version $updversion " > $ACUVR/acuversion 2>> $PROTO
case $KUNDE in
     wahr)     echo "Xenergy Wahr Version $updversion " > $ACUVR/acuversion 2>> $PROTO
     ;;
     bww)      echo "Xenergy BWW Version $updversion " > $ACUVR/acuversion 2>> $PROTO
     ;;
     luehmann) echo "Xenergy CLASSIC Version $updversion " > $ACUVR/acuversion 2>> $PROTO
     ;;
     sln2)     echo "Xenergy SLN2 Version $updversion " > $ACUVR/acuversion 2>> $PROTO
     ;;
esac
#hw
cat $ACUVR/xoilversion >> xoilversion.alt 2>> $PROTO
echo $updversion > $ACUVR/xoilversion 2>> $PROTO
###
###--------------- Verzeichnisse fuer Remoteuntersttzung anlegen
###
###
#hw#cd /u/xpoint
#hw#echo "    - neue Verzeichnisse anlegen"
#hw#echo "    - neue Verzeichnisse anlegen" >> $PROTO
#hw#mkdir -p /u/xpoint/prog/teamviewer 2>> $PROTO
#hw#mkdir -p $ACUVR/upd/Xoil-FTP 2>> $PROTO
#hw#mkdir -p $ACUVR/upd/config 2>> $PROTO
#hw#echo "    - Rechte in neuen Verzeichnissen setzen"
#hw#echo "    - Rechte in neuen Verzeichnisse setzen    " >> $PROTO
#hw#chmod -R 777 /u/xpoint/prog
#hw#chmod -R 777 $ACUVR/upd
###
###--------------- Sambafreigabe, Prog-Verzeichnis anlegen
###
#echo "    - Freigabe prog einrichten"
#echo "    - Freigabe 'prog' einrichten" >> $PROTO
#$ACUVR/SCRIPTS/freigabe.sh
#/bin/rm -f $ACUVR/SCRIPTS/freigabe.sh
###
###--------------- aktuelle Teamviewer_QS.exe verteilen
###
#hw#echo "    - Teamviewer_QS aktualisieren"
#hw#echo "    - Teamviewer_QS aktualisieren" >> $PROTO
#hw#cd /u/xpoint
#hw#cp -r xpv/prog /u/xpoint/ 2>> $PROTO
#hw#chmod -R 777 /u/xpoint/prog
###
###--------------- Kopie des Updateprotokoll erstellen, falls das
###                Orginal (.DRU) vom Benutzer zuvor geloescht wird!
###
echo "                                                         " >> $PROTO
echo " ------------------------------------------------------- " >> $PROTO
echo " -- Ende start.sh -------------------------------------- " >> $PROTO
cp -f $PROTO $ACUVR/LISTE/UPDPRT_$updversion.log
###
###--------------- Endemeldung, Abschluss
###
echo "                                                         "
echo " ------------------------------------------------------- "
echo "                                                         "
echo "    Ende der Updateroutine                               "
echo "                                                         "
echo "    WEITER mit Enter \c"
read eingabe
#***********************************************************************
#*END*OF*start.sh*******************************************************
